/*
 * Copyright COCKTAIL (www.cocktail.org), 1995, 2012 This software 
 * is governed by the CeCILL license under French law and abiding by the
 * rules of distribution of free software. You can use, modify and/or 
 * redistribute the software under the terms of the CeCILL license as 
 * circulated by CEA, CNRS and INRIA at the following URL 
 * "http://www.cecill.info". 
 * As a counterpart to the access to the source code and rights to copy, modify 
 * and redistribute granted by the license, users are provided only with a 
 * limited warranty and the software's author, the holder of the economic 
 * rights, and the successive licensors have only limited liability. In this 
 * respect, the user's attention is drawn to the risks associated with loading,
 * using, modifying and/or developing or reproducing the software by the user 
 * in light of its specific status of free software, that may mean that it
 * is complicated to manipulate, and that also therefore means that it is 
 * reserved for developers and experienced professionals having in-depth
 * computer knowledge. Users are therefore encouraged to load and test the 
 * software's suitability as regards their requirements in conditions enabling
 * the security of their systems and/or data to be ensured and, more generally, 
 * to use and operate it in the same conditions as regards security. The
 * fact that you are presently reading this means that you have had knowledge 
 * of the CeCILL license and that you accept its terms.
 */
package org.cocktail.carambole.server.components;

// Generated by the WOLips Templateengine Plug-in at 11 fevr. 2007 18:19:53

import org.cocktail.carambole.server.MyAjaxPage;
import org.cocktail.fwkcktldepense.server.finder.FinderCommande;
import org.cocktail.fwkcktldepense.server.finder.FinderSaCommande;
import org.cocktail.fwkcktldepense.server.metier.EOCommande;
import org.cocktail.fwkcktldepense.server.metier.EOExercice;
import org.cocktail.fwkcktldepense.server.metier.EOIndividu;
import org.cocktail.fwkcktldepense.server.metier.EOSaCommande;
import org.cocktail.fwkcktldepense.server.metier.EOUtilisateur;
import org.cocktail.fwkcktlwebapp.common.database.CktlUserInfoDB;
import org.cocktail.fwkcktlwebapp.server.CktlMailBus;

import com.webobjects.appserver.WOComponent;
import com.webobjects.appserver.WOContext;
import com.webobjects.eoaccess.EOUtilities;
import com.webobjects.eocontrol.EOEditingContext;

public class CommandeApresEnregistrement extends MyAjaxPage {

	private static final long serialVersionUID = 1L;
	private boolean isValidationServiceAchatNecessaire = true;
	private EOSaCommande sa = null;
	public String observations = null;

	public CommandeApresEnregistrement(WOContext context) {
		super(context);
		reinitialiserLaCommandeEnCours();
	}

	public boolean isValidationServiceAchatNecessaire() {
		if (isValidationServiceAchatNecessaire) {
			EOCommande commande = laCommandeEnCours();
			if (commande != null) {
				// La commande necessite t-elle la validation du service achat ?
				sa = FinderSaCommande.getSaCommande(commande.editingContext(), commande);
				if (sa != null) {
					isValidationServiceAchatNecessaire = true;
				}
				else {
					isValidationServiceAchatNecessaire = false;
				}
			}
		}
		return isValidationServiceAchatNecessaire;

	}

	public boolean isNotValidationServiceAchatNecessaire() {
		return !isValidationServiceAchatNecessaire;
	}

	public WOComponent envoyerDemandeValidationServiceAchat() {
		isValidationServiceAchatNecessaire = false;
		EOCommande commande = laCommandeEnCours();
		CktlMailBus cmb = session.mailBus();
		String smtpServeur = myApp().config().stringForKey("GRHUM_HOST_MAIL");
		if (sa != null && sa.saEmails() != null && sa.saEmails().equals("") == false &&
				commande != null && cmb != null && smtpServeur != null && smtpServeur.equals("") == false) {
			// Envoi du mail de la demande de validation
			CktlUserInfoDB utilisateurInfos = new CktlUserInfoDB(session.dataBus());
			EOUtilisateur utilisateur = session.getUtilisateur();
			EOIndividu individu = utilisateur.individu();
			Integer noIndividu = (Integer) EOUtilities.primaryKeyForObject(individu.editingContext(), individu).allValues().lastObject();
			utilisateurInfos.individuForNoIndividu(noIndividu, true);
			String objet = "[Carambole] : DEMANDE DE VALIDATION DE LA COMMANDE Nº " + commande.commNumero();
			String contenu = objet;
			contenu += "\n\n";
			contenu += "La commande nº " + commande.commNumero() + " demande validation de la part du service des achats avant de pouvoir être éditée.";
			contenu += "\n\n";
			contenu += "Observations:\n";
			if (getObservations() != null) {
				contenu += getObservations();
			}
			contenu += "\n\n";
			contenu += "Merci de bien vouloir valider cette commande.";
			boolean forTest = myApp().test();
			if (forTest == false) {
				cmb.sendMail(utilisateurInfos.email(), sa.saEmails(), null, objet, contenu);
			}
			else {
				String contenuTest = "TEST de mail de demande de validation de la part du service des achats";
				contenuTest += "\n\nDestinataire(s): " + sa.saEmails();
				contenu = contenuTest + contenu;
				cmb.sendMail(utilisateurInfos.email(), myApp().appAdminMail(), null, objet, contenu);
			}
		}
		// Affichage des differents traitements possibles apres enregistrement et validation (qd necessaire)
		return null;
	}

	public WOComponent informer() {
		Informer nextPage = null;
		EOCommande commande = laCommandeEnCours();
		nextPage = (Informer) pageWithName("Informer");
		nextPage.setCommande(commande);

		return nextPage;

	}

	public WOComponent imprimer() {
		Imprimer nextPage = null;
		EOCommande commande = laCommandeEnCours();
		nextPage = (Imprimer) pageWithName("Imprimer");
		nextPage.setCommande(commande);
		nextPage.initialiser();
		return nextPage;
	}

	public WOComponent envoyerCommandeB2b() {
		B2BOrderRequestPage nextPage = null;
		EOCommande commande = laCommandeEnCours();
		nextPage = (B2BOrderRequestPage) pageWithName(B2BOrderRequestPage.class.getName());
		nextPage.setCommande(commande);
		//nextPage.initialiser();
		return nextPage;
	}

	public WOComponent detailler() {
		DetailCommande nextPage = null;
		EOCommande commande = laCommandeEnCours();
		nextPage = (DetailCommande) pageWithName("DetailCommande");
		nextPage.setLaCommande(commande);

		return nextPage;
	}

	public WOComponent afficherAccueil() {
		Accueil nextPage = (Accueil) pageWithName("Accueil");
		nextPage.reset();
		return nextPage;
	}

	public String getObservations() {
		return observations;
	}

	public void setObservations(String observations) {
		this.observations = observations;
	}

	private void reinitialiserLaCommandeEnCours() {
		EOCommande commande = laCommandeEnCours();
		if (commande != null) {
			EOEditingContext edc = commande.editingContext();
			EOExercice exercice = commande.exercice();
			Number numero = commande.commNumero();
			commande = FinderCommande.getCommande(edc, exercice, numero);
			session.setLaCommandeEnCours(commande);
		}
	}

}